/*
 * This is a roxen module.
 * tag <trimpath>
 *
 * Copyright:
 *   None! Do with it as you wish, but let me know if you do anything cool!
 *
 * Author:
 *   Thomas Koester <rufus@uos.de>
 *
 * Bugs:
 *   None, I swear! But if you find one, mailto: rufus@uos.de ;-)
 *
 * To Do:
 *   
 *
 * History:
 *   0.1 1998/08/11 First version. unpublished.			(rufus)
 *   0.2 1998/08/14 Added docs and options 'link' and 'long'	(rufus)
 *   0.3 1999/06/22 Added prestate support and option 'nopre'	(rufus)
 *   0.4 1999/06/22 Fixed prestate support with option 'url'	(rufus)
 *
 */


constant cvs_version = "$Id: trimpath.pike,v 0.4 1999/06/22 05:08:52 tkoester Exp $";
constant thread_safe=1;

#include <module.h>
inherit "module";
inherit "roxenlib";

string tagname;
int usecount;

void create()
{
	defvar( "tagname", "trimpath", "Tag name", TYPE_STRING, 
		"Name off the tag\n"
	);
}

array register_module()
{
	return( ({ MODULE_PARSER, 
		"Trimpath tag",
		"Trim URLs to be correct!<p>"
		"Adds a new tag &lt;trimpath&gt; which wipes out incorrect "
		"parts of the current (or specified) URL.<p>"
		"Syntax: <code>&lt;trimpath [url=\"url\"] [long] [link] [nopre]&gt;</code><p>"
		"<dl><dt>The main purpose of this tag is to put it in the "
		"<a href=\"Global/Messages/No%20such%20file/\">"
		"'No such file' message</a> with a text like:"
		"<dd><code>The requested URL &lt;strong&gt;$File&lt;/strong&gt; cannot be found.&lt;p&gt;<br>"
		"Maybe you will find what you're looking for in &lt;trimpath long link&gt;</code></dd></dl><p>"
		"You can watch this module running at "
		"<a href=\"http://www.usf.uos.de/some/where/~tkoester/foo/index.en.html\">"
		"http://www.usf.uos.de/some/where/~tkoester/foo/index.en.html</a>.<p>",
		0,
		1 }) );
}

string status()
{
	return "Called " + usecount + " times.";
}

// the tag
string tag_trimpath( string tag, mapping args, object id, object file, mapping defines )
{
	string out="/";
	string path;
	array (string) parts;
	int i=0;

	parts=(args->url?args->url:id->not_query) / "/";

	while(++i<sizeof(parts)) {
		path=out+parts[i];
		if(i<sizeof(parts)-1) path+="/";
		if(string s=id->conf->real_file(path, id)) out=path;
	}    

	if(!args->nopre && sizeof(id->prestate)) {
		string prestate;
		if(sscanf(args->url?args->url:id->raw_url,"/(%s)",prestate))
			out="/("+prestate+")"+out;
	}

	path=out;

	if(args->long)
		out=id->conf->query("MyWorldLocation")+path[1..];

	if(args->link)
		out="<a href=\""+path+"\">"+out+"</a>";

	usecount++ ;
	return out ;
}


void start() // read the definitions from the config interface
{
	tagname=query("tagname");
	return;
}


mapping query_tag_callers()
{
	return ([ tagname : tag_trimpath ]);
}
